with Ada.Text_IO;         use Ada.Text_IO;
with Ada.Command_Line;    use Ada.Command_Line;

procedure QUCS.datasets.IO.test is
   D : Dataset;

   procedure Print_Entry (Pos : Cursor) is
      Deps : Name_Lists.Vector := Dependencies (Pos);
   begin
      if Deps.Is_Empty then
         Put_Line ("Independent variable "
                   &
                   "'" & Name (Pos) & "'"
                   &
                   " with " & Integer'Image (Get (Pos).Total_Size)
                   &
                   " elements");
      else
         Put_Line ("Dependent variable "
                   &
                   "'" & Name (Pos) & "'"
                   &
                   " with " & Integer'Image (Get (Pos).Total_Size)
                   &
                   " elements. Depends on");

         for I in Deps.First_Index .. Deps.Last_Index loop
            Put_Line ("     '" & Deps.Element (I) & "'");
         end loop;
      end if;

      New_Line;
   end Print_Entry;
begin
   if Argument_Count  /= 1 then
      Put_Line ("Usage: test input-file");
      Set_Exit_Status (Failure);
      return;
   end if;

   D := Load (Argument (1));

   D.Iterate (Print_Entry'Access);
end QUCS.datasets.IO.test;
