package body QUCS.Variables is
   use Ada.Containers;
   ----------
   -- Prod --
   ----------

   function Prod (X : Dim_Array) return Count_Type is
      Result : Count_Type := 1;
   begin
      for I in X'Range loop
         Result := Result * Count_Type (X (I));
      end loop;

      return Result;
   end Prod;

   ------------
   -- Create --
   ------------

   function Create (Size : Positive) return Variable is
      use Ada.Containers;
   begin
      return Create ((1 => Size));
   end Create;


   ------------
   -- Create --
   ------------

   function Create (Size : Dim_Array) return Variable is
--        function Expand (X : Dim_Array) return Dimension_Array is
--           Result : Dimension_Array (Dimensionality) := (others => 1);
--        begin
--           Result  :=
--           return Result;
--        end Expand;

      Result : Variable;
   begin
      Result := (N_Dims => Size'Length,
                 Dims   => (others => 1),
                 Data   => Float_Vectors.To_Vector
                   (New_Item => 0.0,
                    Length   => Prod (Size)));

      Result.Dims (1 .. Size'Length) := Dimension_Array (Size);
      return Result;
   end Create;



--     ------------
--     -- Append --
--     ------------
--
--     procedure Append
--       (Item  : in out Variable;
--        Value : Float)
--     is
--     begin
--        Item.Data.Append (Value);
--     end Append;

   ----------
   -- Size --
   ----------

   function Size (Item : Variable) return Positive is
   begin
      return Positive (Item.Data.Length);
   end Size;

   ----------
   -- Size --
   ----------

   function Size (Item : Variable) return Dim_Array is
   begin
      return Dim_Array (Item.Dims (1 .. Item.N_Dims));
   end Size;

   ---------
   -- Set --
   ---------

   procedure Set
     (Item  : in out Variable;
      Index : Positive;
      Value : Float)
   is
   begin
      Item.Data.Replace_Element (Index, Value);
   end Set;

   ---------
   -- Get --
   ---------

   function Get
     (Item  : Variable;
      Index : Positive)
      return Float
   is
   begin
      return Item.Data.Element (Index);
   end Get;

   --------------
   -- To_Array --
   --------------

   function To_Array (Item : Variable)
                      return Float_Array
   is
      Result : Float_Array (1 .. Size (Item));
   begin
      for I in Result'Range loop
         Result (I) := Float_Type (Item.Get (I));
      end loop;

      return Result;
   end To_Array;

   function Total_Size (Item  : Variable) return Positive is
   begin
      return Positive (Item.Data.Length);
   end Total_Size;
end QUCS.Variables;
